import logging

logger = logging.getLogger(__name__)


class Bus:
    def __init__(self, workers=[]):
        self.workers = workers

    def dispatch(self, event):
        if not event:
            return
        logger.debug(event)
        event_ids = []
        for worker in self.workers:
            if worker.accepts(event):
                event_id = worker.handle(event)
                event_ids.append(event_id)
        return event_ids
