#!/usr/bin/python
"""Containers Configuration"""

import copy

# ================================================================================
# format is directory:label name (matches Kolla)
# data container is purposely excluded (& no more needed for osp10+)

# Blacklisted: congress, tacker
CONTAINERS_13_0 = [
    ['openstack-base-container', 'openstack-base'],
    ['openstack-barbican-base-container', 'openstack-barbican-base'],
    ['openstack-barbican-api-container', 'openstack-barbican-api'],
    ['openstack-barbican-keystone-listener-container', 'openstack-barbican-keystone-listener'],
    ['openstack-barbican-worker-container', 'openstack-barbican-worker'],
    ['openstack-ceilometer-base-container', 'openstack-ceilometer-base'],
    ['openstack-ceilometer-central-container', 'openstack-ceilometer-central'],
    ['openstack-ceilometer-compute-container', 'openstack-ceilometer-compute'],
    ['openstack-ceilometer-ipmi-container', 'openstack-ceilometer-ipmi'],
    ['openstack-ceilometer-notification-container', 'openstack-ceilometer-notification'],
    ['openstack-cinder-base-container', 'openstack-cinder-base'],
    ['openstack-cinder-api-container', 'openstack-cinder-api'],
    ['openstack-cinder-backup-container', 'openstack-cinder-backup'],
    ['openstack-cinder-scheduler-container', 'openstack-cinder-scheduler'],
    ['openstack-cinder-volume-container', 'openstack-cinder-volume'],
    ['openstack-collectd-container', 'openstack-collectd'],
    ['openstack-cron-container', 'openstack-cron'],
    ['openstack-ec2-api-container', 'openstack-ec2-api'],
    ['openstack-etcd-container', 'openstack-etcd'],
    ['openstack-fluentd-container', 'openstack-fluentd'],
    ['openstack-haproxy-container', 'openstack-haproxy'],
    ['openstack-iscsid-container', 'openstack-iscsid'],
    ['openstack-manila-api-container', 'openstack-manila-api'],
    ['openstack-manila-base-container', 'openstack-manila-base'],
    ['openstack-manila-scheduler-container', 'openstack-manila-scheduler'],
    ['openstack-manila-share-container', 'openstack-manila-share'],
    ['openstack-multipathd-container', 'openstack-multipathd'],
    ['openstack-mariadb-container', 'openstack-mariadb'],
    ['openstack-nova-libvirt-container', 'openstack-nova-libvirt'],
    ['openstack-memcached-container', 'openstack-memcached'],
    ['openstack-dependencies-container', 'openstack-dependencies'],
    ['openstack-ironic-base-container', 'openstack-ironic-base'],
    ['openstack-ironic-pxe-container', 'openstack-ironic-pxe'],
    ['openstack-ironic-conductor-container', 'openstack-ironic-conductor'],
    ['openstack-ironic-inspector-container', 'openstack-ironic-inspector'],
    ['openstack-ironic-api-container', 'openstack-ironic-api'],
    ['openstack-neutron-base-container', 'openstack-neutron-base'],
    ['openstack-neutron-dhcp-agent-container', 'openstack-neutron-dhcp-agent'],
    ['openstack-neutron-l3-agent-container', 'openstack-neutron-l3-agent'],
    ['openstack-neutron-metadata-agent-container', 'openstack-neutron-metadata-agent'],
    ['openstack-neutron-metadata-agent-ovn-container', 'openstack-neutron-metadata-agent-ovn'],
    ['openstack-neutron-openvswitch-agent-container', 'openstack-neutron-openvswitch-agent'],
    ['openstack-neutron-server-container', 'openstack-neutron-server'],
    ['openstack-neutron-server-ovn-container', 'openstack-neutron-server-ovn'],
    ['openstack-neutron-sriov-agent-container', 'openstack-neutron-sriov-agent'],
    ['openstack-mistral-base-container', 'openstack-mistral-base'],
    ['openstack-mistral-api-container', 'openstack-mistral-api'],
    ['openstack-mistral-engine-container', 'openstack-mistral-engine'],
    ['openstack-mistral-event-engine-container', 'openstack-mistral-event-engine'],
    ['openstack-mistral-executor-container', 'openstack-mistral-executor'],
    ['openstack-sahara-api-container', 'openstack-sahara-api'],
    ['openstack-sahara-base-container', 'openstack-sahara-base'],
    ['openstack-sahara-engine-container', 'openstack-sahara-engine'],
    ['openstack-swift-base-container', 'openstack-swift-base'],
    ['openstack-swift-proxy-server-container', 'openstack-swift-proxy-server'],
    ['openstack-swift-object-container', 'openstack-swift-object'],
    ['openstack-swift-account-container', 'openstack-swift-account'],
    ['openstack-swift-container-container', 'openstack-swift-container'],
    ['openstack-glance-base-container', 'openstack-glance-base'],
    ['openstack-glance-api-container', 'openstack-glance-api'],
    ['openstack-keystone-base-container', 'openstack-keystone-base'],
    ['openstack-keystone-container', 'openstack-keystone'],
    ['openstack-panko-base-container', 'openstack-panko-base'],
    ['openstack-panko-api-container', 'openstack-panko-api'],
    ['openstack-aodh-base-container', 'openstack-aodh-base'],
    ['openstack-aodh-notifier-container', 'openstack-aodh-notifier'],
    ['openstack-aodh-api-container', 'openstack-aodh-api'],
    ['openstack-aodh-evaluator-container', 'openstack-aodh-evaluator'],
    ['openstack-aodh-listener-container', 'openstack-aodh-listener'],
    ['openstack-gnocchi-base-container', 'openstack-gnocchi-base'],
    ['openstack-gnocchi-statsd-container', 'openstack-gnocchi-statsd'],
    ['openstack-gnocchi-metricd-container', 'openstack-gnocchi-metricd'],
    ['openstack-gnocchi-api-container', 'openstack-gnocchi-api'],
    ['openstack-heat-base-container', 'openstack-heat-base'],
    ['openstack-heat-all-container', 'openstack-heat-all'],
    ['openstack-heat-api-container', 'openstack-heat-api'],
    ['openstack-heat-api-cfn-container', 'openstack-heat-api-cfn'],
    ['openstack-heat-engine-container', 'openstack-heat-engine'],
    ['openstack-horizon-container', 'openstack-horizon'],
    ['openstack-nova-base-container', 'openstack-nova-base'],
    ['openstack-nova-api-container', 'openstack-nova-api'],
    ['openstack-nova-compute-ironic-container', 'openstack-nova-compute-ironic'],
    ['openstack-nova-compute-container', 'openstack-nova-compute'],
    ['openstack-nova-consoleauth-container', 'openstack-nova-consoleauth'],
    ['openstack-nova-novncproxy-container', 'openstack-nova-novncproxy'],
    ['openstack-nova-placement-api-container', 'openstack-nova-placement-api'],
    ['openstack-nova-conductor-container', 'openstack-nova-conductor'],
    ['openstack-nova-scheduler-container', 'openstack-nova-scheduler'],
    ['openstack-octavia-api-container', 'openstack-octavia-api'],
    ['openstack-octavia-base-container', 'openstack-octavia-base'],
    ['openstack-octavia-health-manager-container', 'openstack-octavia-health-manager'],
    ['openstack-octavia-housekeeping-container', 'openstack-octavia-housekeeping'],
    ['openstack-octavia-worker-container', 'openstack-octavia-worker'],
    ['openstack-openvswitch-base-container', 'openstack-openvswitch-base'],
    ['openstack-ovn-base-container', 'openstack-ovn-base'],
    ['openstack-ovn-controller-container', 'openstack-ovn-controller'],
    ['openstack-ovn-nb-db-server-container', 'openstack-ovn-nb-db-server'],
    ['openstack-ovn-northd-container', 'openstack-ovn-northd'],
    ['openstack-ovn-sb-db-server-container', 'openstack-ovn-sb-db-server'],
    ['openstack-sensu-base-container', 'openstack-sensu-base'],
    ['openstack-sensu-client-container', 'openstack-sensu-client'],
    ['openstack-tempest-container', 'openstack-tempest'],
    ['openstack-zaqar-container', 'openstack-zaqar'],
    ['openstack-redis-base-container', 'openstack-redis-base'],
    ['openstack-redis-container', 'openstack-redis'],
    ['openstack-rabbitmq-container', 'openstack-rabbitmq'],
    ['openstack-qdrouterd-container', 'openstack-qdrouterd'],
    ['openstack-ironic-neutron-agent-container', 'openstack-ironic-neutron-agent'],
]

# Blacklisted: congress, tacker
CONTAINERS_14_0 = CONTAINERS_13_0[:]
CONTAINERS_14_0.extend([
    ['openstack-keepalived-container', 'openstack-keepalived'],
    ['openstack-tripleo-ui-container', 'openstack-tripleo-ui'],
    ['openstack-designate-api-container', 'openstack-designate-api'],
    ['openstack-designate-backend-bind9-container', 'openstack-designate-backend-bind9'],
    ['openstack-designate-base-container', 'openstack-designate-base'],
    ['openstack-designate-central-container', 'openstack-designate-central'],
    ['openstack-designate-mdns-container', 'openstack-designate-mdns'],
    ['openstack-designate-producer-container', 'openstack-designate-producer'],
    ['openstack-designate-sink-container', 'openstack-designate-sink'],
    ['openstack-designate-worker-container', 'openstack-designate-worker'],
    ['openstack-novajoin-base-container', 'openstack-novajoin-base'],
    ['openstack-novajoin-notifier-container', 'openstack-novajoin-notifier'],
    ['openstack-novajoin-server-container', 'openstack-novajoin-server'],
    ['openstack-skydive-agent-container', 'openstack-skydive-agent'],
    ['openstack-skydive-analyzer-container', 'openstack-skydive-analyzer'],
    ['openstack-skydive-base-container', 'openstack-skydive-base'],
])

# Blacklisted: congress, tacker, opendaylight
CONTAINERS_15_0 = [
    ['openstack-base-container', 'openstack-base'],
    ['openstack-barbican-base-container', 'openstack-barbican-base'],
    ['openstack-barbican-api-container', 'openstack-barbican-api'],
    ['openstack-barbican-keystone-listener-container', 'openstack-barbican-keystone-listener'],
    ['openstack-barbican-worker-container', 'openstack-barbican-worker'],
    ['openstack-ceilometer-base-container', 'openstack-ceilometer-base'],
    ['openstack-ceilometer-central-container', 'openstack-ceilometer-central'],
    ['openstack-ceilometer-compute-container', 'openstack-ceilometer-compute'],
    ['openstack-ceilometer-ipmi-container', 'openstack-ceilometer-ipmi'],
    ['openstack-ceilometer-notification-container', 'openstack-ceilometer-notification'],
    ['openstack-cinder-base-container', 'openstack-cinder-base'],
    ['openstack-cinder-api-container', 'openstack-cinder-api'],
    ['openstack-cinder-backup-container', 'openstack-cinder-backup'],
    ['openstack-cinder-scheduler-container', 'openstack-cinder-scheduler'],
    ['openstack-cinder-volume-container', 'openstack-cinder-volume'],
    ['openstack-collectd-container', 'openstack-collectd'],
    ['openstack-cron-container', 'openstack-cron'],
    ['openstack-ec2-api-container', 'openstack-ec2-api'],
    ['openstack-etcd-container', 'openstack-etcd'],
    ['openstack-fluentd-container', 'openstack-fluentd'],
    ['openstack-haproxy-container', 'openstack-haproxy'],
    ['openstack-iscsid-container', 'openstack-iscsid'],
    ['openstack-manila-api-container', 'openstack-manila-api'],
    ['openstack-manila-base-container', 'openstack-manila-base'],
    ['openstack-manila-scheduler-container', 'openstack-manila-scheduler'],
    ['openstack-manila-share-container', 'openstack-manila-share'],
    ['openstack-multipathd-container', 'openstack-multipathd'],
    ['openstack-mariadb-container', 'openstack-mariadb'],
    ['openstack-nova-libvirt-container', 'openstack-nova-libvirt'],
    ['openstack-memcached-container', 'openstack-memcached'],
    ['openstack-dependencies-container', 'openstack-dependencies'],
    ['openstack-ironic-base-container', 'openstack-ironic-base'],
    ['openstack-ironic-pxe-container', 'openstack-ironic-pxe'],
    ['openstack-ironic-conductor-container', 'openstack-ironic-conductor'],
    ['openstack-ironic-inspector-container', 'openstack-ironic-inspector'],
    ['openstack-ironic-api-container', 'openstack-ironic-api'],
    ['openstack-neutron-base-container', 'openstack-neutron-base'],
    ['openstack-neutron-dhcp-agent-container', 'openstack-neutron-dhcp-agent'],
    ['openstack-neutron-l3-agent-container', 'openstack-neutron-l3-agent'],
    ['openstack-neutron-metadata-agent-container', 'openstack-neutron-metadata-agent'],
    ['openstack-neutron-metadata-agent-ovn-container', 'openstack-neutron-metadata-agent-ovn'],
    ['openstack-neutron-openvswitch-agent-container', 'openstack-neutron-openvswitch-agent'],
    ['openstack-neutron-server-container', 'openstack-neutron-server'],
    ['openstack-neutron-server-ovn-container', 'openstack-neutron-server-ovn'],
    ['openstack-neutron-sriov-agent-container', 'openstack-neutron-sriov-agent'],
    ['openstack-mistral-base-container', 'openstack-mistral-base'],
    ['openstack-mistral-api-container', 'openstack-mistral-api'],
    ['openstack-mistral-engine-container', 'openstack-mistral-engine'],
    ['openstack-mistral-event-engine-container', 'openstack-mistral-event-engine'],
    ['openstack-mistral-executor-container', 'openstack-mistral-executor'],
    ['openstack-sahara-api-container', 'openstack-sahara-api'],
    ['openstack-sahara-base-container', 'openstack-sahara-base'],
    ['openstack-sahara-engine-container', 'openstack-sahara-engine'],
    ['openstack-swift-base-container', 'openstack-swift-base'],
    ['openstack-swift-proxy-server-container', 'openstack-swift-proxy-server'],
    ['openstack-swift-object-container', 'openstack-swift-object'],
    ['openstack-swift-account-container', 'openstack-swift-account'],
    ['openstack-swift-container-container', 'openstack-swift-container'],
    ['openstack-glance-base-container', 'openstack-glance-base'],
    ['openstack-glance-api-container', 'openstack-glance-api'],
    ['openstack-keystone-base-container', 'openstack-keystone-base'],
    ['openstack-keystone-container', 'openstack-keystone'],
    ['openstack-panko-base-container', 'openstack-panko-base'],
    ['openstack-panko-api-container', 'openstack-panko-api'],
    ['openstack-aodh-base-container', 'openstack-aodh-base'],
    ['openstack-aodh-notifier-container', 'openstack-aodh-notifier'],
    ['openstack-aodh-api-container', 'openstack-aodh-api'],
    ['openstack-aodh-evaluator-container', 'openstack-aodh-evaluator'],
    ['openstack-aodh-listener-container', 'openstack-aodh-listener'],
    ['openstack-gnocchi-base-container', 'openstack-gnocchi-base'],
    ['openstack-gnocchi-statsd-container', 'openstack-gnocchi-statsd'],
    ['openstack-gnocchi-metricd-container', 'openstack-gnocchi-metricd'],
    ['openstack-gnocchi-api-container', 'openstack-gnocchi-api'],
    ['openstack-heat-base-container', 'openstack-heat-base'],
    ['openstack-heat-all-container', 'openstack-heat-all'],
    ['openstack-heat-api-container', 'openstack-heat-api'],
    ['openstack-heat-api-cfn-container', 'openstack-heat-api-cfn'],
    ['openstack-heat-engine-container', 'openstack-heat-engine'],
    ['openstack-horizon-container', 'openstack-horizon'],
    ['openstack-nova-base-container', 'openstack-nova-base'],
    ['openstack-nova-api-container', 'openstack-nova-api'],
    ['openstack-nova-compute-ironic-container', 'openstack-nova-compute-ironic'],
    ['openstack-nova-compute-container', 'openstack-nova-compute'],
    ['openstack-nova-consoleauth-container', 'openstack-nova-consoleauth'],
    ['openstack-nova-novncproxy-container', 'openstack-nova-novncproxy'],
    ['openstack-nova-placement-api-container', 'openstack-nova-placement-api'],
    ['openstack-nova-conductor-container', 'openstack-nova-conductor'],
    ['openstack-nova-scheduler-container', 'openstack-nova-scheduler'],
    ['openstack-octavia-api-container', 'openstack-octavia-api'],
    ['openstack-octavia-base-container', 'openstack-octavia-base'],
    ['openstack-octavia-health-manager-container', 'openstack-octavia-health-manager'],
    ['openstack-octavia-housekeeping-container', 'openstack-octavia-housekeeping'],
    ['openstack-octavia-worker-container', 'openstack-octavia-worker'],
    ['openstack-openvswitch-base-container', 'openstack-openvswitch-base'],
    ['openstack-ovn-base-container', 'openstack-ovn-base'],
    ['openstack-ovn-controller-container', 'openstack-ovn-controller'],
    ['openstack-ovn-nb-db-server-container', 'openstack-ovn-nb-db-server'],
    ['openstack-ovn-northd-container', 'openstack-ovn-northd'],
    ['openstack-ovn-sb-db-server-container', 'openstack-ovn-sb-db-server'],
    ['openstack-sensu-base-container', 'openstack-sensu-base'],
    ['openstack-sensu-client-container', 'openstack-sensu-client'],
    ['openstack-tempest-container', 'openstack-tempest'],
    ['openstack-zaqar-base-container', 'openstack-zaqar-base'],
    ['openstack-zaqar-wsgi-container', 'openstack-zaqar-wsgi'],
    ['openstack-redis-base-container', 'openstack-redis-base'],
    ['openstack-redis-container', 'openstack-redis'],
    ['openstack-rabbitmq-container', 'openstack-rabbitmq'],
    ['openstack-keepalived-container', 'openstack-keepalived'],
    ['openstack-ironic-neutron-agent-container', 'openstack-ironic-neutron-agent'],
    ['openstack-novajoin-base-container', 'openstack-novajoin-base'],
    ['openstack-novajoin-notifier-container', 'openstack-novajoin-notifier'],
    ['openstack-novajoin-server-container', 'openstack-novajoin-server'],
    ['openstack-qdrouterd-container', 'openstack-qdrouterd'],
]

# Blacklisted: congress, tacker, opendaylight
CONTAINERS_16_0 = [
    ['openstack-base-container', 'openstack-base'],
    ['openstack-barbican-base-container', 'openstack-barbican-base'],
    ['openstack-barbican-api-container', 'openstack-barbican-api'],
    ['openstack-barbican-keystone-listener-container', 'openstack-barbican-keystone-listener'],
    ['openstack-barbican-worker-container', 'openstack-barbican-worker'],
    ['openstack-ceilometer-base-container', 'openstack-ceilometer-base'],
    ['openstack-ceilometer-central-container', 'openstack-ceilometer-central'],
    ['openstack-ceilometer-compute-container', 'openstack-ceilometer-compute'],
    ['openstack-ceilometer-ipmi-container', 'openstack-ceilometer-ipmi'],
    ['openstack-ceilometer-notification-container', 'openstack-ceilometer-notification'],
    ['openstack-cinder-base-container', 'openstack-cinder-base'],
    ['openstack-cinder-api-container', 'openstack-cinder-api'],
    ['openstack-cinder-backup-container', 'openstack-cinder-backup'],
    ['openstack-cinder-scheduler-container', 'openstack-cinder-scheduler'],
    ['openstack-cinder-volume-container', 'openstack-cinder-volume'],
    ['openstack-collectd-container', 'openstack-collectd'],
    ['openstack-cron-container', 'openstack-cron'],
    ['openstack-ec2-api-container', 'openstack-ec2-api'],
    ['openstack-etcd-container', 'openstack-etcd'],
    ['openstack-haproxy-container', 'openstack-haproxy'],
    ['openstack-iscsid-container', 'openstack-iscsid'],
    ['openstack-manila-api-container', 'openstack-manila-api'],
    ['openstack-manila-base-container', 'openstack-manila-base'],
    ['openstack-manila-scheduler-container', 'openstack-manila-scheduler'],
    ['openstack-manila-share-container', 'openstack-manila-share'],
    ['openstack-multipathd-container', 'openstack-multipathd'],
    ['openstack-mariadb-container', 'openstack-mariadb'],
    ['openstack-nova-libvirt-container', 'openstack-nova-libvirt'],
    ['openstack-memcached-container', 'openstack-memcached'],
    ['openstack-dependencies-container', 'openstack-dependencies'],
    ['openstack-ironic-base-container', 'openstack-ironic-base'],
    ['openstack-ironic-pxe-container', 'openstack-ironic-pxe'],
    ['openstack-ironic-conductor-container', 'openstack-ironic-conductor'],
    ['openstack-ironic-inspector-container', 'openstack-ironic-inspector'],
    ['openstack-ironic-api-container', 'openstack-ironic-api'],
    ['openstack-neutron-base-container', 'openstack-neutron-base'],
    ['openstack-neutron-dhcp-agent-container', 'openstack-neutron-dhcp-agent'],
    ['openstack-neutron-l3-agent-container', 'openstack-neutron-l3-agent'],
    ['openstack-neutron-metadata-agent-container', 'openstack-neutron-metadata-agent'],
    ['openstack-neutron-metadata-agent-ovn-container', 'openstack-neutron-metadata-agent-ovn'],
    ['openstack-neutron-openvswitch-agent-container', 'openstack-neutron-openvswitch-agent'],
    ['openstack-neutron-server-container', 'openstack-neutron-server'],
    ['openstack-neutron-server-ovn-container', 'openstack-neutron-server-ovn'],
    ['openstack-neutron-sriov-agent-container', 'openstack-neutron-sriov-agent'],
    ['openstack-mistral-base-container', 'openstack-mistral-base'],
    ['openstack-mistral-api-container', 'openstack-mistral-api'],
    ['openstack-mistral-engine-container', 'openstack-mistral-engine'],
    ['openstack-mistral-event-engine-container', 'openstack-mistral-event-engine'],
    ['openstack-mistral-executor-container', 'openstack-mistral-executor'],
    ['openstack-placement-base-container', 'openstack-placement-base'],
    ['openstack-placement-api-container', 'openstack-placement-api'],
    ['openstack-rsyslog-base-container', 'openstack-rsyslog-base'],
    ['openstack-rsyslog-container', 'openstack-rsyslog'],
    ['openstack-swift-base-container', 'openstack-swift-base'],
    ['openstack-swift-proxy-server-container', 'openstack-swift-proxy-server'],
    ['openstack-swift-object-container', 'openstack-swift-object'],
    ['openstack-swift-account-container', 'openstack-swift-account'],
    ['openstack-swift-container-container', 'openstack-swift-container'],
    ['openstack-glance-base-container', 'openstack-glance-base'],
    ['openstack-glance-api-container', 'openstack-glance-api'],
    ['openstack-keystone-base-container', 'openstack-keystone-base'],
    ['openstack-keystone-container', 'openstack-keystone'],
    ['openstack-panko-base-container', 'openstack-panko-base'],
    ['openstack-panko-api-container', 'openstack-panko-api'],
    ['openstack-aodh-base-container', 'openstack-aodh-base'],
    ['openstack-aodh-notifier-container', 'openstack-aodh-notifier'],
    ['openstack-aodh-api-container', 'openstack-aodh-api'],
    ['openstack-aodh-evaluator-container', 'openstack-aodh-evaluator'],
    ['openstack-aodh-listener-container', 'openstack-aodh-listener'],
    ['openstack-gnocchi-base-container', 'openstack-gnocchi-base'],
    ['openstack-gnocchi-statsd-container', 'openstack-gnocchi-statsd'],
    ['openstack-gnocchi-metricd-container', 'openstack-gnocchi-metricd'],
    ['openstack-gnocchi-api-container', 'openstack-gnocchi-api'],
    ['openstack-heat-base-container', 'openstack-heat-base'],
    ['openstack-heat-all-container', 'openstack-heat-all'],
    ['openstack-heat-api-container', 'openstack-heat-api'],
    ['openstack-heat-api-cfn-container', 'openstack-heat-api-cfn'],
    ['openstack-heat-engine-container', 'openstack-heat-engine'],
    ['openstack-horizon-container', 'openstack-horizon'],
    ['openstack-nova-base-container', 'openstack-nova-base'],
    ['openstack-nova-api-container', 'openstack-nova-api'],
    ['openstack-nova-compute-ironic-container', 'openstack-nova-compute-ironic'],
    ['openstack-nova-compute-container', 'openstack-nova-compute'],
    ['openstack-nova-novncproxy-container', 'openstack-nova-novncproxy'],
    ['openstack-nova-conductor-container', 'openstack-nova-conductor'],
    ['openstack-nova-scheduler-container', 'openstack-nova-scheduler'],
    ['openstack-octavia-api-container', 'openstack-octavia-api'],
    ['openstack-octavia-base-container', 'openstack-octavia-base'],
    ['openstack-octavia-health-manager-container', 'openstack-octavia-health-manager'],
    ['openstack-octavia-housekeeping-container', 'openstack-octavia-housekeeping'],
    ['openstack-octavia-worker-container', 'openstack-octavia-worker'],
    ['openstack-openvswitch-base-container', 'openstack-openvswitch-base'],
    ['openstack-ovn-base-container', 'openstack-ovn-base'],
    ['openstack-ovn-controller-container', 'openstack-ovn-controller'],
    ['openstack-ovn-nb-db-server-container', 'openstack-ovn-nb-db-server'],
    ['openstack-ovn-northd-container', 'openstack-ovn-northd'],
    ['openstack-ovn-sb-db-server-container', 'openstack-ovn-sb-db-server'],
    ['openstack-tempest-container', 'openstack-tempest'],
    ['openstack-zaqar-base-container', 'openstack-zaqar-base'],
    ['openstack-zaqar-wsgi-container', 'openstack-zaqar-wsgi'],
    ['openstack-redis-base-container', 'openstack-redis-base'],
    ['openstack-redis-container', 'openstack-redis'],
    ['openstack-rabbitmq-container', 'openstack-rabbitmq'],
    ['openstack-keepalived-container', 'openstack-keepalived'],
    ['openstack-ironic-neutron-agent-container', 'openstack-ironic-neutron-agent'],
    ['openstack-novajoin-base-container', 'openstack-novajoin-base'],
    ['openstack-novajoin-notifier-container', 'openstack-novajoin-notifier'],
    ['openstack-novajoin-server-container', 'openstack-novajoin-server'],
    ['openstack-qdrouterd-container', 'openstack-qdrouterd'],
]

CONTAINERS_16_1 = copy.copy(CONTAINERS_16_0)

CONTAINERS_16_1.extend([
    ['openstack-designate-api-container', 'openstack-designate-api'],
    ['openstack-designate-backend-bind9-container', 'openstack-designate-backend-bind9'],
    ['openstack-designate-base-container', 'openstack-designate-base'],
    ['openstack-designate-central-container', 'openstack-designate-central'],
    ['openstack-designate-mdns-container', 'openstack-designate-mdns'],
    ['openstack-designate-producer-container', 'openstack-designate-producer'],
    ['openstack-designate-sink-container', 'openstack-designate-sink'],
    ['openstack-designate-worker-container', 'openstack-designate-worker']])

CONTAINERS_16_2 = copy.copy(CONTAINERS_16_1)

CONTAINERS_16_2.extend([
    ['openstack-neutron-agent-base-container', 'openstack-neutron-agent-base'],
    ['openstack-tripleoclient-container', 'openstack-tripleoclient']])

CONTAINERS_16_2_remove = [
    ['openstack-glance-base-container', 'openstack-glance-base'],
    ['openstack-keystone-base-container', 'openstack-keystone-base'],
    ['openstack-openvswitch-base-container', 'openstack-openvswitch-base'],
    ['openstack-panko-base-container', 'openstack-panko-base'],
    ['openstack-placement-base-container', 'openstack-placement-base'],
    ['openstack-redis-base-container', 'openstack-redis-base'],
    ['openstack-rsyslog-base-container', 'openstack-rsyslog-base'],
    ['openstack-zaqar-base-container', 'openstack-zaqar-base']]

for container in CONTAINERS_16_2_remove:
    CONTAINERS_16_2.remove(container)

CONTAINERS_17_0 = copy.copy(CONTAINERS_16_2)

# Dropped in 17.0
CONTAINERS_17_0_remove = [
    ['openstack-ec2-api-container', 'openstack-ec2-api'],
    ['openstack-keepalived-container', 'openstack-keepalived'],
    ['openstack-mistral-base-container', 'openstack-mistral-base'],
    ['openstack-mistral-api-container', 'openstack-mistral-api'],
    ['openstack-mistral-engine-container', 'openstack-mistral-engine'],
    ['openstack-mistral-event-engine-container', 'openstack-mistral-event-engine'],
    ['openstack-mistral-executor-container', 'openstack-mistral-executor'],
    ['openstack-neutron-server-ovn-container', 'openstack-neutron-server-ovn'],
    ['openstack-panko-api-container', 'openstack-panko-api'],
    ['openstack-zaqar-wsgi-container', 'openstack-zaqar-wsgi']]

for container in CONTAINERS_17_0_remove:
    CONTAINERS_17_0.remove(container)

CONTAINERS_17_1 = copy.copy(CONTAINERS_17_0)

CONTAINERS = {
    '13.0': CONTAINERS_13_0,
    '14.0': CONTAINERS_14_0,
    '15.0': CONTAINERS_15_0,
    '16.0': CONTAINERS_16_0,
    '16.1': CONTAINERS_16_1,
    '16.2': CONTAINERS_16_2,
    '17.0': CONTAINERS_17_0,
    '17.1': CONTAINERS_17_1,
}

TECH_PREVIEW_13_0 = [
]

TECH_PREVIEW_14_0 = [
]

TECH_PREVIEW_15_0 = [
]

TECH_PREVIEW_16_0 = [
]

TECH_PREVIEW_16_1 = [
]

TECH_PREVIEW_16_2 = [
]

TECH_PREVIEW_17_0 = [
]

TECH_PREVIEW_17_1 = [
]

TECH_PREVIEW = {
    '13.0': TECH_PREVIEW_13_0,
    '14.0': TECH_PREVIEW_14_0,
    '15.0': TECH_PREVIEW_15_0,
    '16.0': TECH_PREVIEW_16_0,
    '16.1': TECH_PREVIEW_16_1,
    '16.2': TECH_PREVIEW_16_2,
    '17.0': TECH_PREVIEW_17_0,
    '17.1': TECH_PREVIEW_17_1,
}

# ================================================================================
# (map RHOS/OSP containers to Kolla's containers)

# map RHOS/OSP containers to Kolla's containers:
# format is directory:kolla_directory_name
# data container is purposely excluded

# auto-generated:
UPSTREAM_CONT_13_0 = [
    ['openstack-base-container', 'base'],
    ['openstack-barbican-base-container', 'barbican/barbican-base'],
    ['openstack-barbican-api-container', 'barbican/barbican-api'],
    ['openstack-barbican-keystone-listener-container', 'barbican/barbican-keystone-listener'],
    ['openstack-barbican-worker-container', 'barbican/barbican-worker'],
    ['openstack-cinder-base-container', 'cinder/cinder-base'],
    ['openstack-cinder-api-container', 'cinder/cinder-api'],
    ['openstack-cinder-backup-container', 'cinder/cinder-backup'],
    ['openstack-cinder-scheduler-container', 'cinder/cinder-scheduler'],
    ['openstack-cinder-volume-container', 'cinder/cinder-volume'],
    ['openstack-collectd-container', 'collectd'],
    ['openstack-cron-container', 'cron'],
    ['openstack-ec2-api-container', 'ec2-api'],
    ['openstack-etcd-container', 'etcd'],
    ['openstack-fluentd-container', 'fluentd'],
    ['openstack-haproxy-container', 'haproxy'],
    ['openstack-iscsid-container', 'iscsid'],
    ['openstack-manila-api-container', 'manila/manila-api'],
    ['openstack-manila-base-container', 'manila/manila-base'],
    ['openstack-manila-scheduler-container', 'manila/manila-scheduler'],
    ['openstack-manila-share-container', 'manila/manila-share'],
    ['openstack-multipathd-container', 'multipathd'],
    ['openstack-mariadb-container', 'mariadb'],
    ['openstack-nova-libvirt-container', 'nova/nova-libvirt'],
    ['openstack-memcached-container', 'memcached'],
    ['openstack-dependencies-container', 'openstack-base'],
    ['openstack-ironic-base-container', 'ironic/ironic-base'],
    ['openstack-ironic-pxe-container', 'ironic/ironic-pxe'],
    ['openstack-ironic-conductor-container', 'ironic/ironic-conductor'],
    ['openstack-ironic-inspector-container', 'ironic-inspector'],
    ['openstack-ironic-api-container', 'ironic/ironic-api'],
    ['openstack-neutron-base-container', 'neutron/neutron-base'],
    ['openstack-neutron-dhcp-agent-container', 'neutron/neutron-dhcp-agent'],
    ['openstack-neutron-l3-agent-container', 'neutron/neutron-l3-agent'],
    ['openstack-neutron-metadata-agent-container', 'neutron/neutron-metadata-agent'],
    ['openstack-neutron-metadata-agent-ovn-container', 'neutron/neutron-metadata-agent-ovn'],
    ['openstack-neutron-openvswitch-agent-container', 'neutron/neutron-openvswitch-agent'],
    ['openstack-neutron-server-container', 'neutron/neutron-server'],
    ['openstack-neutron-server-ovn-container', 'neutron/neutron-server-ovn'],
    ['openstack-neutron-sriov-agent-container', 'neutron/neutron-sriov-agent'],
    ['openstack-mistral-base-container', 'mistral/mistral-base'],
    ['openstack-mistral-engine-container', 'mistral/mistral-engine'],
    ['openstack-mistral-api-container', 'mistral/mistral-api'],
    ['openstack-mistral-event-engine-container', 'mistral/mistral-event-engine'],
    ['openstack-mistral-executor-container', 'mistral/mistral-executor'],
    ['openstack-sahara-api-container', 'sahara/sahara-api'],
    ['openstack-sahara-base-container', 'sahara/sahara-base'],
    ['openstack-sahara-engine-container', 'sahara/sahara-engine'],
    ['openstack-swift-base-container', 'swift/swift-base'],
    ['openstack-swift-proxy-server-container', 'swift/swift-proxy-server'],
    ['openstack-swift-object-container', 'swift/swift-object'],
    ['openstack-swift-account-container', 'swift/swift-account'],
    ['openstack-swift-container-container', 'swift/swift-container'],
    ['openstack-glance-base-container', 'glance/glance-base'],
    ['openstack-glance-api-container', 'glance/glance-api'],
    ['openstack-keystone-base-container', 'keystone/keystone-base'],
    ['openstack-keystone-container', 'keystone/keystone'],
    ['openstack-panko-base-container', 'panko/panko-base'],
    ['openstack-panko-api-container', 'panko/panko-api'],
    ['openstack-aodh-base-container', 'aodh/aodh-base'],
    ['openstack-aodh-notifier-container', 'aodh/aodh-notifier'],
    ['openstack-aodh-api-container', 'aodh/aodh-api'],
    ['openstack-aodh-evaluator-container', 'aodh/aodh-evaluator'],
    ['openstack-aodh-listener-container', 'aodh/aodh-listener'],
    ['openstack-ceilometer-base-container', 'ceilometer/ceilometer-base'],
    ['openstack-ceilometer-central-container', 'ceilometer/ceilometer-central'],
    ['openstack-ceilometer-compute-container', 'ceilometer/ceilometer-compute'],
    ['openstack-ceilometer-ipmi-container', 'ceilometer/ceilometer-ipmi'],
    ['openstack-ceilometer-notification-container', 'ceilometer/ceilometer-notification'],
    ['openstack-gnocchi-base-container', 'gnocchi/gnocchi-base'],
    ['openstack-gnocchi-statsd-container', 'gnocchi/gnocchi-statsd'],
    ['openstack-gnocchi-metricd-container', 'gnocchi/gnocchi-metricd'],
    ['openstack-gnocchi-api-container', 'gnocchi/gnocchi-api'],
    ['openstack-heat-base-container', 'heat/heat-base'],
    ['openstack-heat-all-container', 'heat/heat-all'],
    ['openstack-heat-api-container', 'heat/heat-api'],
    ['openstack-heat-api-cfn-container', 'heat/heat-api-cfn'],
    ['openstack-heat-engine-container', 'heat/heat-engine'],
    ['openstack-horizon-container', 'horizon'],
    ['openstack-nova-base-container', 'nova/nova-base'],
    ['openstack-nova-api-container', 'nova/nova-api'],
    ['openstack-nova-compute-ironic-container', 'nova/nova-compute-ironic'],
    ['openstack-nova-compute-container', 'nova/nova-compute'],
    ['openstack-nova-consoleauth-container', 'nova/nova-consoleauth'],
    ['openstack-nova-novncproxy-container', 'nova/nova-novncproxy'],
    ['openstack-nova-placement-api-container', 'nova/nova-placement-api'],
    ['openstack-nova-conductor-container', 'nova/nova-conductor'],
    ['openstack-nova-scheduler-container', 'nova/nova-scheduler'],
    ['openstack-octavia-api-container', 'octavia/octavia-api'],
    ['openstack-octavia-base-container', 'octavia/octavia-base'],
    ['openstack-octavia-health-manager-container', 'octavia/octavia-health-manager'],
    ['openstack-octavia-housekeeping-container', 'octavia/octavia-housekeeping'],
    ['openstack-octavia-worker-container', 'octavia/octavia-worker'],
    ['openstack-openvswitch-base-container', 'openvswitch/openvswitch-base'],
    ['openstack-ovn-base-container', 'ovn/ovn-base'],
    ['openstack-ovn-controller-container', 'ovn/ovn-controller'],
    ['openstack-ovn-nb-db-server-container', 'ovn/ovn-nb-db-server'],
    ['openstack-ovn-northd-container', 'ovn/ovn-northd'],
    ['openstack-ovn-sb-db-server-container', 'ovn/ovn-sb-db-server'],
    ['openstack-redis-base-container', 'redis/redis-base'],
    ['openstack-redis-container', 'redis/redis'],
    ['openstack-sensu-base-container', 'sensu/sensu-base'],
    ['openstack-sensu-client-container', 'sensu/sensu-client'],
    ['openstack-tempest-container', 'tempest'],
    ['openstack-zaqar-container', 'zaqar'],
    ['openstack-rabbitmq-container', 'rabbitmq'],
    ['openstack-qdrouterd-container', 'qdrouterd'],
    ['openstack-ironic-neutron-agent-container', 'networking-baremetal/ironic-neutron-agent'],
]

UPSTREAM_CONT_14_0 = UPSTREAM_CONT_13_0[:]
UPSTREAM_CONT_14_0.extend([
    ['openstack-keepalived-container', 'keepalived'],
    ['openstack-tripleo-ui-container', 'tripleo-ui'],
    ['openstack-designate-api-container', 'designate/designate-api'],
    ['openstack-designate-backend-bind9-container', 'designate/designate-backend-bind9'],
    ['openstack-designate-base-container', 'designate/designate-base'],
    ['openstack-designate-central-container', 'designate/designate-central'],
    ['openstack-designate-mdns-container', 'designate/designate-mdns'],
    ['openstack-designate-producer-container', 'designate/designate-producer'],
    ['openstack-designate-sink-container', 'designate/designate-sink'],
    ['openstack-designate-worker-container', 'designate/designate-worker'],
    ['openstack-novajoin-base-container', 'novajoin/novajoin-base'],
    ['openstack-novajoin-notifier-container', 'novajoin/novajoin-notifier'],
    ['openstack-novajoin-server-container', 'novajoin/novajoin-server'],
    ['openstack-skydive-agent-container', 'skydive/skydive-agent'],
    ['openstack-skydive-analyzer-container', 'skydive/skydive-analyzer'],
    ['openstack-skydive-base-container', 'skydive/skydive-base'],
])

UPSTREAM_CONT_15_0 = [
    ['openstack-base-container', 'base'],
    ['openstack-barbican-base-container', 'barbican/barbican-base'],
    ['openstack-barbican-api-container', 'barbican/barbican-api'],
    ['openstack-barbican-keystone-listener-container', 'barbican/barbican-keystone-listener'],
    ['openstack-barbican-worker-container', 'barbican/barbican-worker'],
    ['openstack-cinder-base-container', 'cinder/cinder-base'],
    ['openstack-cinder-api-container', 'cinder/cinder-api'],
    ['openstack-cinder-backup-container', 'cinder/cinder-backup'],
    ['openstack-cinder-scheduler-container', 'cinder/cinder-scheduler'],
    ['openstack-cinder-volume-container', 'cinder/cinder-volume'],
    ['openstack-collectd-container', 'collectd'],
    ['openstack-cron-container', 'cron'],
    ['openstack-ec2-api-container', 'ec2-api'],
    ['openstack-etcd-container', 'etcd'],
    ['openstack-fluentd-container', 'fluentd'],
    ['openstack-haproxy-container', 'haproxy'],
    ['openstack-iscsid-container', 'iscsid'],
    ['openstack-manila-api-container', 'manila/manila-api'],
    ['openstack-manila-base-container', 'manila/manila-base'],
    ['openstack-manila-scheduler-container', 'manila/manila-scheduler'],
    ['openstack-manila-share-container', 'manila/manila-share'],
    ['openstack-multipathd-container', 'multipathd'],
    ['openstack-mariadb-container', 'mariadb'],
    ['openstack-nova-libvirt-container', 'nova/nova-libvirt'],
    ['openstack-memcached-container', 'memcached'],
    ['openstack-dependencies-container', 'openstack-base'],
    ['openstack-ironic-base-container', 'ironic/ironic-base'],
    ['openstack-ironic-pxe-container', 'ironic/ironic-pxe'],
    ['openstack-ironic-conductor-container', 'ironic/ironic-conductor'],
    ['openstack-ironic-inspector-container', 'ironic-inspector'],
    ['openstack-ironic-api-container', 'ironic/ironic-api'],
    ['openstack-neutron-base-container', 'neutron/neutron-base'],
    ['openstack-neutron-dhcp-agent-container', 'neutron/neutron-dhcp-agent'],
    ['openstack-neutron-l3-agent-container', 'neutron/neutron-l3-agent'],
    ['openstack-neutron-metadata-agent-container', 'neutron/neutron-metadata-agent'],
    ['openstack-neutron-metadata-agent-ovn-container', 'neutron/neutron-metadata-agent-ovn'],
    ['openstack-neutron-openvswitch-agent-container', 'neutron/neutron-openvswitch-agent'],
    ['openstack-neutron-server-container', 'neutron/neutron-server'],
    ['openstack-neutron-server-ovn-container', 'neutron/neutron-server-ovn'],
    ['openstack-neutron-sriov-agent-container', 'neutron/neutron-sriov-agent'],
    ['openstack-mistral-base-container', 'mistral/mistral-base'],
    ['openstack-mistral-engine-container', 'mistral/mistral-engine'],
    ['openstack-mistral-api-container', 'mistral/mistral-api'],
    ['openstack-mistral-event-engine-container', 'mistral/mistral-event-engine'],
    ['openstack-mistral-executor-container', 'mistral/mistral-executor'],
    ['openstack-sahara-api-container', 'sahara/sahara-api'],
    ['openstack-sahara-base-container', 'sahara/sahara-base'],
    ['openstack-sahara-engine-container', 'sahara/sahara-engine'],
    ['openstack-swift-base-container', 'swift/swift-base'],
    ['openstack-swift-proxy-server-container', 'swift/swift-proxy-server'],
    ['openstack-swift-object-container', 'swift/swift-object'],
    ['openstack-swift-account-container', 'swift/swift-account'],
    ['openstack-swift-container-container', 'swift/swift-container'],
    ['openstack-glance-base-container', 'glance/glance-base'],
    ['openstack-glance-api-container', 'glance/glance-api'],
    ['openstack-keystone-base-container', 'keystone/keystone-base'],
    ['openstack-keystone-container', 'keystone/keystone'],
    ['openstack-panko-base-container', 'panko/panko-base'],
    ['openstack-panko-api-container', 'panko/panko-api'],
    ['openstack-aodh-base-container', 'aodh/aodh-base'],
    ['openstack-aodh-notifier-container', 'aodh/aodh-notifier'],
    ['openstack-aodh-api-container', 'aodh/aodh-api'],
    ['openstack-aodh-evaluator-container', 'aodh/aodh-evaluator'],
    ['openstack-aodh-listener-container', 'aodh/aodh-listener'],
    ['openstack-ceilometer-base-container', 'ceilometer/ceilometer-base'],
    ['openstack-ceilometer-central-container', 'ceilometer/ceilometer-central'],
    ['openstack-ceilometer-compute-container', 'ceilometer/ceilometer-compute'],
    ['openstack-ceilometer-ipmi-container', 'ceilometer/ceilometer-ipmi'],
    ['openstack-ceilometer-notification-container', 'ceilometer/ceilometer-notification'],
    ['openstack-gnocchi-base-container', 'gnocchi/gnocchi-base'],
    ['openstack-gnocchi-statsd-container', 'gnocchi/gnocchi-statsd'],
    ['openstack-gnocchi-metricd-container', 'gnocchi/gnocchi-metricd'],
    ['openstack-gnocchi-api-container', 'gnocchi/gnocchi-api'],
    ['openstack-heat-base-container', 'heat/heat-base'],
    ['openstack-heat-all-container', 'heat/heat-all'],
    ['openstack-heat-api-container', 'heat/heat-api'],
    ['openstack-heat-api-cfn-container', 'heat/heat-api-cfn'],
    ['openstack-heat-engine-container', 'heat/heat-engine'],
    ['openstack-horizon-container', 'horizon'],
    ['openstack-nova-base-container', 'nova/nova-base'],
    ['openstack-nova-api-container', 'nova/nova-api'],
    ['openstack-nova-compute-ironic-container', 'nova/nova-compute-ironic'],
    ['openstack-nova-compute-container', 'nova/nova-compute'],
    ['openstack-nova-consoleauth-container', 'nova/nova-consoleauth'],
    ['openstack-nova-novncproxy-container', 'nova/nova-novncproxy'],
    ['openstack-nova-placement-api-container', 'nova/nova-placement-api'],
    ['openstack-nova-conductor-container', 'nova/nova-conductor'],
    ['openstack-nova-scheduler-container', 'nova/nova-scheduler'],
    ['openstack-octavia-api-container', 'octavia/octavia-api'],
    ['openstack-octavia-base-container', 'octavia/octavia-base'],
    ['openstack-octavia-health-manager-container', 'octavia/octavia-health-manager'],
    ['openstack-octavia-housekeeping-container', 'octavia/octavia-housekeeping'],
    ['openstack-octavia-worker-container', 'octavia/octavia-worker'],
    ['openstack-openvswitch-base-container', 'openvswitch/openvswitch-base'],
    ['openstack-ovn-base-container', 'ovn/ovn-base'],
    ['openstack-ovn-controller-container', 'ovn/ovn-controller'],
    ['openstack-ovn-nb-db-server-container', 'ovn/ovn-nb-db-server'],
    ['openstack-ovn-northd-container', 'ovn/ovn-northd'],
    ['openstack-ovn-sb-db-server-container', 'ovn/ovn-sb-db-server'],
    ['openstack-redis-base-container', 'redis/redis-base'],
    ['openstack-redis-container', 'redis/redis'],
    ['openstack-sensu-base-container', 'sensu/sensu-base'],
    ['openstack-sensu-client-container', 'sensu/sensu-client'],
    ['openstack-tempest-container', 'tempest'],
    ['openstack-zaqar-base-container', 'zaqar/zaqar-base'],
    ['openstack-zaqar-wsgi-container', 'zaqar/zaqar-wsgi'],
    ['openstack-rabbitmq-container', 'rabbitmq'],
    ['openstack-keepalived-container', 'keepalived'],
    ['openstack-ironic-neutron-agent-container', 'networking-baremetal/ironic-neutron-agent'],
    ['openstack-novajoin-base-container', 'novajoin/novajoin-base'],
    ['openstack-novajoin-notifier-container', 'novajoin/novajoin-notifier'],
    ['openstack-novajoin-server-container', 'novajoin/novajoin-server'],
    ['openstack-qdrouterd-container', 'qdrouterd'],
]

UPSTREAM_CONT_16_0 = [
    ['openstack-base-container', 'base'],
    ['openstack-barbican-base-container', 'barbican/barbican-base'],
    ['openstack-barbican-api-container', 'barbican/barbican-api'],
    ['openstack-barbican-keystone-listener-container', 'barbican/barbican-keystone-listener'],
    ['openstack-barbican-worker-container', 'barbican/barbican-worker'],
    ['openstack-cinder-base-container', 'cinder/cinder-base'],
    ['openstack-cinder-api-container', 'cinder/cinder-api'],
    ['openstack-cinder-backup-container', 'cinder/cinder-backup'],
    ['openstack-cinder-scheduler-container', 'cinder/cinder-scheduler'],
    ['openstack-cinder-volume-container', 'cinder/cinder-volume'],
    ['openstack-collectd-container', 'collectd'],
    ['openstack-cron-container', 'cron'],
    ['openstack-ec2-api-container', 'ec2-api'],
    ['openstack-etcd-container', 'etcd'],
    ['openstack-haproxy-container', 'haproxy'],
    ['openstack-iscsid-container', 'iscsid'],
    ['openstack-manila-api-container', 'manila/manila-api'],
    ['openstack-manila-base-container', 'manila/manila-base'],
    ['openstack-manila-scheduler-container', 'manila/manila-scheduler'],
    ['openstack-manila-share-container', 'manila/manila-share'],
    ['openstack-multipathd-container', 'multipathd'],
    ['openstack-mariadb-container', 'mariadb'],
    ['openstack-nova-libvirt-container', 'nova/nova-libvirt'],
    ['openstack-memcached-container', 'memcached'],
    ['openstack-dependencies-container', 'openstack-base'],
    ['openstack-ironic-base-container', 'ironic/ironic-base'],
    ['openstack-ironic-pxe-container', 'ironic/ironic-pxe'],
    ['openstack-ironic-conductor-container', 'ironic/ironic-conductor'],
    ['openstack-ironic-inspector-container', 'ironic-inspector'],
    ['openstack-ironic-api-container', 'ironic/ironic-api'],
    ['openstack-neutron-base-container', 'neutron/neutron-base'],
    ['openstack-neutron-dhcp-agent-container', 'neutron/neutron-dhcp-agent'],
    ['openstack-neutron-l3-agent-container', 'neutron/neutron-l3-agent'],
    ['openstack-neutron-metadata-agent-container', 'neutron/neutron-metadata-agent'],
    ['openstack-neutron-metadata-agent-ovn-container', 'neutron/neutron-metadata-agent-ovn'],
    ['openstack-neutron-openvswitch-agent-container', 'neutron/neutron-openvswitch-agent'],
    ['openstack-neutron-server-container', 'neutron/neutron-server'],
    ['openstack-neutron-server-ovn-container', 'neutron/neutron-server-ovn'],
    ['openstack-neutron-sriov-agent-container', 'neutron/neutron-sriov-agent'],
    ['openstack-mistral-base-container', 'mistral/mistral-base'],
    ['openstack-mistral-engine-container', 'mistral/mistral-engine'],
    ['openstack-mistral-api-container', 'mistral/mistral-api'],
    ['openstack-mistral-event-engine-container', 'mistral/mistral-event-engine'],
    ['openstack-mistral-executor-container', 'mistral/mistral-executor'],
    ['openstack-placement-base-container', 'placement/placement-base'],
    ['openstack-placement-api-container', 'placement/placement-api'],
    ['openstack-rsyslog-base-container', 'rsyslog/rsyslog-base'],
    ['openstack-rsyslog-container', 'rsyslog/rsyslog'],
    ['openstack-swift-base-container', 'swift/swift-base'],
    ['openstack-swift-proxy-server-container', 'swift/swift-proxy-server'],
    ['openstack-swift-object-container', 'swift/swift-object'],
    ['openstack-swift-account-container', 'swift/swift-account'],
    ['openstack-swift-container-container', 'swift/swift-container'],
    ['openstack-glance-base-container', 'glance/glance-base'],
    ['openstack-glance-api-container', 'glance/glance-api'],
    ['openstack-keystone-base-container', 'keystone/keystone-base'],
    ['openstack-keystone-container', 'keystone/keystone'],
    ['openstack-panko-base-container', 'panko/panko-base'],
    ['openstack-panko-api-container', 'panko/panko-api'],
    ['openstack-aodh-base-container', 'aodh/aodh-base'],
    ['openstack-aodh-notifier-container', 'aodh/aodh-notifier'],
    ['openstack-aodh-api-container', 'aodh/aodh-api'],
    ['openstack-aodh-evaluator-container', 'aodh/aodh-evaluator'],
    ['openstack-aodh-listener-container', 'aodh/aodh-listener'],
    ['openstack-ceilometer-base-container', 'ceilometer/ceilometer-base'],
    ['openstack-ceilometer-central-container', 'ceilometer/ceilometer-central'],
    ['openstack-ceilometer-compute-container', 'ceilometer/ceilometer-compute'],
    ['openstack-ceilometer-ipmi-container', 'ceilometer/ceilometer-ipmi'],
    ['openstack-ceilometer-notification-container', 'ceilometer/ceilometer-notification'],
    ['openstack-gnocchi-base-container', 'gnocchi/gnocchi-base'],
    ['openstack-gnocchi-statsd-container', 'gnocchi/gnocchi-statsd'],
    ['openstack-gnocchi-metricd-container', 'gnocchi/gnocchi-metricd'],
    ['openstack-gnocchi-api-container', 'gnocchi/gnocchi-api'],
    ['openstack-heat-base-container', 'heat/heat-base'],
    ['openstack-heat-all-container', 'heat/heat-all'],
    ['openstack-heat-api-container', 'heat/heat-api'],
    ['openstack-heat-api-cfn-container', 'heat/heat-api-cfn'],
    ['openstack-heat-engine-container', 'heat/heat-engine'],
    ['openstack-horizon-container', 'horizon'],
    ['openstack-nova-base-container', 'nova/nova-base'],
    ['openstack-nova-api-container', 'nova/nova-api'],
    ['openstack-nova-compute-ironic-container', 'nova/nova-compute-ironic'],
    ['openstack-nova-compute-container', 'nova/nova-compute'],
    ['openstack-nova-novncproxy-container', 'nova/nova-novncproxy'],
    ['openstack-nova-conductor-container', 'nova/nova-conductor'],
    ['openstack-nova-scheduler-container', 'nova/nova-scheduler'],
    ['openstack-octavia-api-container', 'octavia/octavia-api'],
    ['openstack-octavia-base-container', 'octavia/octavia-base'],
    ['openstack-octavia-health-manager-container', 'octavia/octavia-health-manager'],
    ['openstack-octavia-housekeeping-container', 'octavia/octavia-housekeeping'],
    ['openstack-octavia-worker-container', 'octavia/octavia-worker'],
    ['openstack-openvswitch-base-container', 'openvswitch/openvswitch-base'],
    ['openstack-ovn-base-container', 'ovn/ovn-base'],
    ['openstack-ovn-controller-container', 'ovn/ovn-controller'],
    ['openstack-ovn-nb-db-server-container', 'ovn/ovn-nb-db-server'],
    ['openstack-ovn-northd-container', 'ovn/ovn-northd'],
    ['openstack-ovn-sb-db-server-container', 'ovn/ovn-sb-db-server'],
    ['openstack-redis-base-container', 'redis/redis-base'],
    ['openstack-redis-container', 'redis/redis'],
    ['openstack-tempest-container', 'tempest'],
    ['openstack-zaqar-base-container', 'zaqar/zaqar-base'],
    ['openstack-zaqar-wsgi-container', 'zaqar/zaqar-wsgi'],
    ['openstack-rabbitmq-container', 'rabbitmq'],
    ['openstack-keepalived-container', 'keepalived'],
    ['openstack-ironic-neutron-agent-container', 'networking-baremetal/ironic-neutron-agent'],
    ['openstack-novajoin-base-container', 'novajoin/novajoin-base'],
    ['openstack-novajoin-notifier-container', 'novajoin/novajoin-notifier'],
    ['openstack-novajoin-server-container', 'novajoin/novajoin-server'],
    ['openstack-qdrouterd-container', 'qdrouterd'],
]

UPSTREAM_CONT_16_1 = copy.copy(UPSTREAM_CONT_16_0)

UPSTREAM_CONT_16_1.extend([
    ['openstack-designate-api-container', 'designate/designate-api'],
    ['openstack-designate-backend-bind9-container', 'designate/designate-backend-bind9'],
    ['openstack-designate-base-container', 'designate/designate-base'],
    ['openstack-designate-central-container', 'designate/designate-central'],
    ['openstack-designate-mdns-container', 'designate/designate-mdns'],
    ['openstack-designate-producer-container', 'designate/designate-producer'],
    ['openstack-designate-sink-container', 'designate/designate-sink'],
    ['openstack-designate-worker-container', 'designate/designate-worker']])

UPSTREAM_CONT_16_2 = copy.copy(UPSTREAM_CONT_16_1)

UPSTREAM_CONT_16_2.extend([
    ['openstack-neutron-agent-base-container', 'neutron/neutron-agent-base'],
    ['openstack-tripleoclient-container', 'tripleoclient']])

UPSTREAM_CONT_16_2_remove = [
    ['openstack-glance-base-container', 'glance/glance-base'],
    ['openstack-keystone-base-container', 'keystone/keystone-base'],
    ['openstack-openvswitch-base-container', 'openvswitch/openvswitch-base'],
    ['openstack-panko-base-container', 'panko/panko-base'],
    ['openstack-placement-base-container', 'placement/placement-base'],
    ['openstack-redis-base-container', 'redis/redis-base'],
    ['openstack-rsyslog-base-container', 'rsyslog/rsyslog-base'],
    ['openstack-zaqar-base-container', 'zaqar/zaqar-base']]

for container in UPSTREAM_CONT_16_2_remove:
    UPSTREAM_CONT_16_2.remove(container)

UPSTREAM_CONT_17_0 = copy.copy(UPSTREAM_CONT_16_2)

UPSTREAM_CONT_17_0_remove = [
    ['openstack-ec2-api-container', 'ec2-api'],
    ['openstack-keepalived-container', 'keepalived'],
    ['openstack-mistral-base-container', 'mistral/mistral-base'],
    ['openstack-mistral-engine-container', 'mistral/mistral-engine'],
    ['openstack-mistral-api-container', 'mistral/mistral-api'],
    ['openstack-mistral-event-engine-container', 'mistral/mistral-event-engine'],
    ['openstack-mistral-executor-container', 'mistral/mistral-executor'],
    ['openstack-neutron-server-ovn-container', 'neutron/neutron-server-ovn'],
    ['openstack-panko-api-container', 'panko/panko-api'],
    ['openstack-zaqar-wsgi-container', 'zaqar/zaqar-wsgi']]

for container in UPSTREAM_CONT_17_0_remove:
    UPSTREAM_CONT_17_0.remove(container)

UPSTREAM_CONT = {
    '13.0': UPSTREAM_CONT_13_0,
    '14.0': UPSTREAM_CONT_14_0,
    '15.0': UPSTREAM_CONT_15_0,
    '16.0': UPSTREAM_CONT_16_0,
    '16.1': UPSTREAM_CONT_16_1,
    '16.2': UPSTREAM_CONT_16_2,
    '17.0': UPSTREAM_CONT_17_0,
}

# base images:
# (note that nova-libvirt's parent was different previous to ocata)
PARENTS = {
    # 'openstack-base-container': '', # autocomputed
    'openstack-aodh-api-container': 'openstack-aodh-base',
    'openstack-aodh-base-container': 'openstack-dependencies',
    'openstack-aodh-evaluator-container': 'openstack-aodh-base',
    'openstack-aodh-listener-container': 'openstack-aodh-base',
    'openstack-aodh-notifier-container': 'openstack-aodh-base',
    'openstack-barbican-base-container': 'openstack-dependencies',
    'openstack-barbican-api-container': 'openstack-barbican-base',
    'openstack-barbican-keystone-listener-container': 'openstack-barbican-base',
    'openstack-barbican-worker-container': 'openstack-barbican-base',
    'openstack-ceilometer-base-container': 'openstack-dependencies',
    'openstack-ceilometer-central-container': 'openstack-ceilometer-base',
    'openstack-ceilometer-compute-container': 'openstack-ceilometer-base',
    'openstack-ceilometer-ipmi-container': 'openstack-ceilometer-base',
    'openstack-ceilometer-notification-container': 'openstack-ceilometer-base',
    'openstack-cinder-api-container': 'openstack-cinder-base',
    'openstack-cinder-backup-container': 'openstack-cinder-base',
    'openstack-cinder-base-container': 'openstack-dependencies',
    'openstack-cinder-scheduler-container': 'openstack-cinder-base',
    'openstack-cinder-volume-container': 'openstack-cinder-base',
    'openstack-collectd-container': 'openstack-dependencies',
    'openstack-cron-container': 'openstack-base',
    'openstack-dependencies-container': 'openstack-base',
    'openstack-designate-api-container': 'openstack-designate-base',
    'openstack-designate-backend-bind9-container': 'openstack-designate-base',
    'openstack-designate-base-container': 'openstack-dependencies',
    'openstack-designate-central-container': 'openstack-designate-base',
    'openstack-designate-mdns-container': 'openstack-designate-base',
    'openstack-designate-producer-container': 'openstack-designate-base',
    'openstack-designate-sink-container': 'openstack-designate-base',
    'openstack-designate-worker-container': 'openstack-designate-base',
    'openstack-ec2-api-container': 'openstack-dependencies',
    'openstack-etcd-container': 'openstack-base',
    'openstack-fluentd-container': 'openstack-base',
    'openstack-glance-api-container': 'openstack-glance-base',
    'openstack-glance-base-container': 'openstack-dependencies',
    'openstack-gnocchi-api-container': 'openstack-gnocchi-base',
    'openstack-gnocchi-base-container': 'openstack-dependencies',
    'openstack-gnocchi-metricd-container': 'openstack-gnocchi-base',
    'openstack-gnocchi-statsd-container': 'openstack-gnocchi-base',
    'openstack-haproxy-container': 'openstack-base',
    'openstack-heat-all-container': 'openstack-heat-base',
    'openstack-heat-api-cfn-container': 'openstack-heat-base',
    'openstack-heat-api-container': 'openstack-heat-base',
    'openstack-heat-base-container': 'openstack-dependencies',
    'openstack-heat-engine-container': 'openstack-heat-base',
    'openstack-horizon-container': 'openstack-dependencies',
    'openstack-ironic-api-container': 'openstack-ironic-base',
    'openstack-ironic-base-container': 'openstack-dependencies',
    'openstack-ironic-conductor-container': 'openstack-ironic-base',
    'openstack-ironic-inspector-container': 'openstack-dependencies',
    'openstack-ironic-neutron-agent-container': 'openstack-neutron-base',
    'openstack-ironic-pxe-container': 'openstack-ironic-base',
    'openstack-iscsid-container': 'openstack-base',
    'openstack-keepalived-container': 'openstack-base',
    'openstack-keystone-base-container': 'openstack-dependencies',
    'openstack-keystone-container': 'openstack-keystone-base',
    'openstack-qdrouterd-container': 'openstack-base',
    'openstack-manila-api-container': 'openstack-manila-base',
    'openstack-manila-base-container': 'openstack-dependencies',
    'openstack-manila-scheduler-container': 'openstack-manila-base',
    'openstack-manila-share-container': 'openstack-manila-base',
    'openstack-mariadb-container': 'openstack-base',
    'openstack-memcached-container': 'openstack-base',
    'openstack-mistral-api-container': 'openstack-mistral-base',
    'openstack-mistral-base-container': 'openstack-dependencies',
    'openstack-mistral-engine-container': 'openstack-mistral-base',
    'openstack-mistral-event-engine-container': 'openstack-mistral-base',
    'openstack-mistral-executor-container': 'openstack-mistral-base',
    'openstack-multipathd-container': 'openstack-base',
    'openstack-neutron-base-container': 'openstack-dependencies',
    'openstack-neutron-dhcp-agent-container': 'openstack-neutron-base',
    'openstack-neutron-l3-agent-container': 'openstack-neutron-base',
    'openstack-neutron-metadata-agent-container': 'openstack-neutron-base',
    'openstack-neutron-metadata-agent-ovn-container': 'openstack-neutron-base',
    'openstack-neutron-openvswitch-agent-container': 'openstack-neutron-base',
    'openstack-neutron-server-container': 'openstack-neutron-base',
    'openstack-neutron-server-ovn-container': 'openstack-neutron-server',
    'openstack-neutron-sriov-agent-container': 'openstack-neutron-base',
    'openstack-nova-api-container': 'openstack-nova-base',
    'openstack-nova-base-container': 'openstack-dependencies',
    'openstack-nova-compute-container': 'openstack-nova-base',
    'openstack-nova-compute-ironic-container': 'openstack-nova-base',
    'openstack-nova-conductor-container': 'openstack-nova-base',
    'openstack-nova-consoleauth-container': 'openstack-nova-base',
    'openstack-nova-libvirt-container': 'openstack-base',
    'openstack-nova-novncproxy-container': 'openstack-nova-base',
    'openstack-nova-placement-api-container': 'openstack-nova-base',
    'openstack-nova-scheduler-container': 'openstack-nova-base',
    'openstack-novajoin-base-container' : 'openstack-dependencies',
    'openstack-novajoin-notifier-container' : 'openstack-novajoin-base',
    'openstack-novajoin-server-container' : 'openstack-novajoin-base',
    'openstack-octavia-api-container': 'openstack-octavia-base',
    'openstack-octavia-base-container': 'openstack-dependencies',
    'openstack-octavia-health-manager-container': 'openstack-octavia-base',
    'openstack-octavia-housekeeping-container': 'openstack-octavia-base',
    'openstack-octavia-worker-container': 'openstack-octavia-base',
    'openstack-ovn-base-container': 'openstack-openvswitch-base',
    'openstack-ovn-controller-container': 'openstack-ovn-base',
    'openstack-ovn-nb-db-server-container': 'openstack-ovn-base',
    'openstack-ovn-northd-container': 'openstack-ovn-base',
    'openstack-ovn-sb-db-server-container': 'openstack-ovn-base',
    'openstack-openvswitch-base-container': 'openstack-base',
    'openstack-openvswitch-db-server-container': 'openstack-openvswitch-base',
    'openstack-openvswitch-vswitchd-container': 'openstack-openvswitch-base',
    'openstack-panko-api-container': 'openstack-panko-base',
    'openstack-panko-base-container': 'openstack-dependencies',
    'openstack-placement-base-container': 'openstack-base',
    'openstack-placement-api-container': 'openstack-placement-base',
    'openstack-rsyslog-base-container': 'openstack-base',
    'openstack-rsyslog-container': 'openstack-rsyslog-base',
    'openstack-rabbitmq-container': 'openstack-base',
    'openstack-redis-base-container': 'openstack-base',
    'openstack-redis-container': 'openstack-redis-base',
    'openstack-sahara-api-container': 'openstack-sahara-base',
    'openstack-sahara-base-container': 'openstack-dependencies',
    'openstack-sahara-engine-container': 'openstack-sahara-base',
    'openstack-sensu-base-container': 'openstack-base',
    'openstack-sensu-client-container': 'openstack-sensu-base',
    'openstack-skydive-agent-container': 'openstack-skydive-base',
    'openstack-skydive-analyzer-container': 'openstack-skydive-base',
    'openstack-skydive-base-container': 'openstack-base',
    'openstack-swift-account-container': 'openstack-swift-base',
    'openstack-swift-base-container': 'openstack-dependencies',
    'openstack-swift-container-container': 'openstack-swift-base',
    'openstack-swift-object-container': 'openstack-swift-base',
    'openstack-swift-proxy-server-container': 'openstack-swift-base',
    'openstack-tripleoclient-container': 'openstack-base',
    'openstack-tempest-container': 'openstack-dependencies',
    'openstack-tripleo-ui-container': 'openstack-dependencies',
    'openstack-zaqar-container': 'openstack-dependencies',
    'openstack-zaqar-base-container': 'openstack-dependencies',
    'openstack-zaqar-wsgi-container': 'openstack-zaqar-base',
}

# A few parents changes as per TCIB.

PARENTS_TCIB = {
    # 'openstack-base-container': '', # autocomputed
    'openstack-aodh-api-container': 'openstack-aodh-base',
    'openstack-aodh-base-container': 'openstack-dependencies',
    'openstack-aodh-evaluator-container': 'openstack-aodh-base',
    'openstack-aodh-listener-container': 'openstack-aodh-base',
    'openstack-aodh-notifier-container': 'openstack-aodh-base',
    'openstack-barbican-base-container': 'openstack-dependencies',
    'openstack-barbican-api-container': 'openstack-barbican-base',
    'openstack-barbican-keystone-listener-container': 'openstack-barbican-base',
    'openstack-barbican-worker-container': 'openstack-barbican-base',
    'openstack-ceilometer-base-container': 'openstack-dependencies',
    'openstack-ceilometer-central-container': 'openstack-ceilometer-base',
    'openstack-ceilometer-compute-container': 'openstack-ceilometer-base',
    'openstack-ceilometer-ipmi-container': 'openstack-ceilometer-base',
    'openstack-ceilometer-notification-container': 'openstack-ceilometer-base',
    'openstack-cinder-api-container': 'openstack-cinder-base',
    'openstack-cinder-backup-container': 'openstack-cinder-base',
    'openstack-cinder-base-container': 'openstack-dependencies',
    'openstack-cinder-scheduler-container': 'openstack-cinder-base',
    'openstack-cinder-volume-container': 'openstack-cinder-base',
    'openstack-collectd-container': 'openstack-dependencies',
    'openstack-cron-container': 'openstack-base',
    'openstack-dependencies-container': 'openstack-base',
    'openstack-designate-api-container': 'openstack-designate-base',
    'openstack-designate-backend-bind9-container': 'openstack-designate-base',
    'openstack-designate-base-container': 'openstack-dependencies',
    'openstack-designate-central-container': 'openstack-designate-base',
    'openstack-designate-mdns-container': 'openstack-designate-base',
    'openstack-designate-producer-container': 'openstack-designate-base',
    'openstack-designate-sink-container': 'openstack-designate-base',
    'openstack-designate-worker-container': 'openstack-designate-base',
    'openstack-ec2-api-container': 'openstack-dependencies',
    'openstack-etcd-container': 'openstack-base',
    'openstack-glance-api-container': 'openstack-dependencies',
    'openstack-gnocchi-api-container': 'openstack-gnocchi-base',
    'openstack-gnocchi-base-container': 'openstack-dependencies',
    'openstack-gnocchi-metricd-container': 'openstack-gnocchi-base',
    'openstack-gnocchi-statsd-container': 'openstack-gnocchi-base',
    'openstack-haproxy-container': 'openstack-base',
    'openstack-heat-all-container': 'openstack-heat-base',
    'openstack-heat-api-cfn-container': 'openstack-heat-base',
    'openstack-heat-api-container': 'openstack-heat-base',
    'openstack-heat-base-container': 'openstack-dependencies',
    'openstack-heat-engine-container': 'openstack-heat-base',
    'openstack-horizon-container': 'openstack-dependencies',
    'openstack-ironic-api-container': 'openstack-ironic-base',
    'openstack-ironic-base-container': 'openstack-dependencies',
    'openstack-ironic-conductor-container': 'openstack-ironic-base',
    'openstack-ironic-inspector-container': 'openstack-dependencies',
    'openstack-ironic-neutron-agent-container': 'openstack-neutron-base',
    'openstack-ironic-pxe-container': 'openstack-ironic-base',
    'openstack-iscsid-container': 'openstack-dependencies',
    'openstack-keepalived-container': 'openstack-base',
    'openstack-keystone-container': 'openstack-dependencies',
    'openstack-qdrouterd-container': 'openstack-base',
    'openstack-manila-api-container': 'openstack-manila-base',
    'openstack-manila-base-container': 'openstack-dependencies',
    'openstack-manila-scheduler-container': 'openstack-manila-base',
    'openstack-manila-share-container': 'openstack-manila-base',
    'openstack-mariadb-container': 'openstack-base',
    'openstack-memcached-container': 'openstack-base',
    'openstack-mistral-api-container': 'openstack-mistral-base',
    'openstack-mistral-base-container': 'openstack-dependencies',
    'openstack-mistral-engine-container': 'openstack-mistral-base',
    'openstack-mistral-event-engine-container': 'openstack-mistral-base',
    'openstack-mistral-executor-container': 'openstack-mistral-base',
    'openstack-multipathd-container': 'openstack-base',
    'openstack-neutron-agent-base-container': 'openstack-neutron-base',
    'openstack-neutron-base-container': 'openstack-dependencies',
    'openstack-neutron-dhcp-agent-container': 'openstack-neutron-agent-base',
    'openstack-neutron-l3-agent-container': 'openstack-neutron-agent-base',
    'openstack-neutron-metadata-agent-container': 'openstack-neutron-agent-base',
    'openstack-neutron-metadata-agent-ovn-container': 'openstack-neutron-base',
    'openstack-neutron-openvswitch-agent-container': 'openstack-neutron-base',
    'openstack-neutron-server-container': 'openstack-neutron-base',
    'openstack-neutron-server-ovn-container': 'openstack-neutron-base',
    'openstack-neutron-sriov-agent-container': 'openstack-neutron-base',
    'openstack-nova-api-container': 'openstack-nova-base',
    'openstack-nova-base-container': 'openstack-dependencies',
    'openstack-nova-compute-container': 'openstack-nova-base',
    'openstack-nova-compute-ironic-container': 'openstack-nova-base',
    'openstack-nova-conductor-container': 'openstack-nova-base',
    'openstack-nova-consoleauth-container': 'openstack-nova-base',
    'openstack-nova-libvirt-container': 'openstack-nova-base',
    'openstack-nova-novncproxy-container': 'openstack-nova-base',
    'openstack-nova-placement-api-container': 'openstack-nova-base',
    'openstack-nova-scheduler-container': 'openstack-nova-base',
    'openstack-novajoin-base-container' : 'openstack-dependencies',
    'openstack-novajoin-notifier-container' : 'openstack-novajoin-base',
    'openstack-novajoin-server-container' : 'openstack-novajoin-base',
    'openstack-octavia-api-container': 'openstack-octavia-base',
    'openstack-octavia-base-container': 'openstack-dependencies',
    'openstack-octavia-health-manager-container': 'openstack-octavia-base',
    'openstack-octavia-housekeeping-container': 'openstack-octavia-base',
    'openstack-octavia-worker-container': 'openstack-octavia-base',
    'openstack-ovn-base-container': 'openstack-base',
    'openstack-ovn-controller-container': 'openstack-ovn-base',
    'openstack-ovn-nb-db-server-container': 'openstack-ovn-base',
    'openstack-ovn-northd-container': 'openstack-ovn-base',
    'openstack-ovn-sb-db-server-container': 'openstack-ovn-base',
    'openstack-panko-api-container': 'openstack-dependencies',
    'openstack-placement-api-container': 'openstack-dependencies',
    'openstack-rsyslog-container': 'openstack-base',
    'openstack-rabbitmq-container': 'openstack-base',
    'openstack-redis-container': 'openstack-base',
    'openstack-swift-account-container': 'openstack-swift-base',
    'openstack-swift-base-container': 'openstack-dependencies',
    'openstack-swift-container-container': 'openstack-swift-base',
    'openstack-swift-object-container': 'openstack-swift-base',
    'openstack-swift-proxy-server-container': 'openstack-swift-base',
    'openstack-tripleoclient-container': 'openstack-base',
    'openstack-tempest-container': 'openstack-dependencies',
    'openstack-zaqar-wsgi-container': 'openstack-dependencies',
}
# ================================================================================
# git branches to use:
BRANCHES = {
    '13.0': 'rhos-13.0-rhel-7',
    '14.0': 'rhos-14.0-rhel-7',
    '15.0': 'rhos-15.0-rhel-8',
    '16.0': 'rhos-16.0-rhel-8',
    '16.1': 'rhos-16.1-rhel-8',
    '16.2': 'rhos-16.2-rhel-8',
    '17.0': 'rhos-17.0-rhel-8',
}
