import requests
import logging

from dcifeeder import settings


logger = logging.getLogger(__name__)


def send_message_on_google_chat(
    message,
    space_id=settings.GOOGLE_CHAT_SPACE_ID,
    key=settings.GOOGLE_CHAT_KEY,
    token=settings.GOOGLE_CHAT_TOKEN,
    thread_id=settings.GOOGLE_CHAT_THREAD_ID,
):
    if not all([space_id, key, token, thread_id]):
        return None
    try:
        url = "https://chat.googleapis.com/v1/spaces/%s/messages?key=%s&token=%s" % (
            space_id,
            key,
            token,
        )
        r = requests.post(
            url,
            json={
                "text": message,
                "thread": {
                    "name": "spaces/%s/threads/%s"
                    % (
                        space_id,
                        thread_id,
                    )
                },
            },
        )
        return r.json()
    except Exception as e:
        logger.exception("Cannot send a message to google chat. Error was: %s" % e)
